require 'spec_helper'
module G5RepsClient
  describe Client do

    let(:lead) do
      {prefix: "Mr.",
       first_name: "G5Test",
       last_name: "Testing",
       suffix: "Jr.",
       address1: "22 Test Drive",
       city: "Bend",
       state: "OR",
       zip_code: "97702",
       phone: "5413334444",
       email: "G5Test@test.com",
       relationship_to_prospect_id: "2",
       source_id: 77}
    end

    let(:client) {G5RepsClient::Client.new("shinyandchrome", "http://test.com?wsdl")}


    describe "initialize" do
      it "assigns" do
        client.instance_variable_get(:@key).should eq("shinyandchrome")
        client.instance_variable_get(:@wsdl).should eq("http://test.com?wsdl")
      end
    end

    describe "get_communities" do
      it "makes a Get Communities Request" do
        expect(GetCommunitiesRequest).to receive(:execute).with("shinyandchrome", "http://test.com?wsdl")
        client.get_communities
      end
    end

    describe "get_pick_lists" do
      it "makes a Get PickLists Request" do
        expect(GetPickListsRequest).to receive(:execute).with("shinyandchrome", "http://test.com?wsdl", "5")
        client.get_pick_lists("5")
      end
    end

    describe "save_lead" do
      it "makes a Save Lead Request" do
        expect(SaveLeadRequest).to receive(:execute).with("shinyandchrome", "http://test.com?wsdl", "5", lead)
        client.save_lead("5", lead)
      end
    end

  end
end
